# Generated by Django 5.0.7 on 2024-07-10 19:32

import barn.models
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Schedule",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("is_active", models.BooleanField(default=True)),
                (
                    "cron",
                    models.CharField(
                        blank=True,
                        help_text="Exactly 5 or 6 columns has to be specified for iterator expression",
                        max_length=200,
                        null=True,
                        validators=[barn.models.validate_cron],
                    ),
                ),
                (
                    "next_run_at",
                    models.DateTimeField(blank=True, db_index=True, null=True),
                ),
                ("last_run_at", models.DateTimeField(blank=True, null=True)),
                ("name", models.CharField(blank=True, max_length=100, null=True)),
                ("func", models.CharField(max_length=1000)),
                ("args", models.JSONField(blank=True, null=True)),
            ],
            options={
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="Task",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("run_at", models.DateTimeField(blank=True, db_index=True)),
                (
                    "status",
                    models.CharField(
                        choices=[("Q", "Queued"), ("D", "Done"), ("F", "Failed")],
                        default="Q",
                        max_length=1,
                    ),
                ),
                ("started_at", models.DateTimeField(blank=True, null=True)),
                ("finished_at", models.DateTimeField(blank=True, null=True)),
                ("error", models.TextField(blank=True, null=True)),
                ("func", models.CharField(max_length=1000)),
                ("args", models.JSONField(blank=True, null=True)),
                ("result", models.JSONField(blank=True, null=True)),
            ],
            options={
                "abstract": False,
            },
        ),
    ]
